clear all


load 'mesh_swim'
%ggf. bisschen mit der viskositaet spielen, damit man im video etwas sieht.
nu = 1e-3;    % --> Reynolds 100

xmin = min(coordinates(:,1));
xmax = max(coordinates(:,1));
ymin = min(coordinates(:,2)); 
ymax = max(coordinates(:,2));

figure(6)
plot(reshape(coordinates(neumann,1),[],2)', ...
     reshape(coordinates(neumann,2),[],2)','r-*');
hold on
plot(reshape(coordinates(dirichlet,1),[],2)', ...
     reshape(coordinates(dirichlet,2),[],2)','k-*');
trisurf(elements,coordinates(:,1),coordinates(:,2),0*coordinates(:,1));
hold off
axis equal


fs  = @(x)  [zeros(size(x,1),1),zeros(size(x,1),1)];



gs  = @(x)  [zeros(size(x,1),1),zeros(size(x,1),1)];
 uDs = @(x)  6*[(x(:,1)==xmin).*ones(size(x,1),1),...
                       zeros(size(x,1),1)];


f  = @(x,t)  [zeros(size(x,1),1),zeros(size(x,1),1)];

g  = @(x,t)  [zeros(size(x,1),1),zeros(size(x,1),1)];

uD = @(x,t) 6*[(x(:,1)==xmin).*ones(size(x,1),1),...
            zeros(size(x,1),1)];



T=1;
%N = ceil(T * 200); 
N = ceil(T * 80);
theta = 0.51;

%*** Refine mesh
for j=1:0
  marked = 1:size(elements,1);
  [coordinates,elements,dirichlet,neumann] = ...
       refine(coordinates,elements,dirichlet,neumann);
end


[U0,P0] = solve_sStokes_Mini(coordinates,elements,dirichlet,neumann, ...
                           uDs,fs,gs,nu);

size(U0), size(P0)
return
x0 = [U0(:);P0(:)];                         
fprintf('Degrees of freedom = %i\n', size(x0,1));
[U,P,t] = solve_iNavierStokes_Mini(coordinates,elements,dirichlet,neumann, ...
                                 uD,f,g,x0,T,N,theta,nu);


save sol_schwimmer coordinates elements dirichlet neumann U P t

return

% der Rest ist in postprocessing --> 1x rechnen, 100x ansehen
load('sol_schwimmer')


h = figure(1)
clf(h)
nC = size(coordinates,1);
for k=1:length(U) 
  %*** plot solution
  hold off
  trisurf(elements,coordinates(:,1),coordinates(:,2), ...
          sqrt(U{k}(1:nC,1).^2+U{k}(1:nC,2).^2), ...
          'facecolor','interp','edgecolor','none')
  view(2)
  axis([xmin,xmax,ymin,ymax])
  axis equal
  axis off
  hold off
  pause(0.001)
end

close all
nC = size(coordinates,1);
trisurf(elements,coordinates(:,1),coordinates(:,2), ...
          sqrt(U0(1:nC,1).^2+U0(1:nC,2).^2), ...
          'facecolor','interp','edgecolor','none')

